
Object subclass: #Calendar
  instanceVariableNames: 
    'month year '
  classVariableNames: ''
  poolDictionaries: '' !

!Calendar class methods ! !


!Calendar methods !

browseMenu
        "pop up menu for the text pane"
    ^Menu
        labels: 'prior year\next year\prior month\next month\set month\set year' withCrs
        lines: #()
        selectors: #(priorYear nextYear priorMonth nextMonth setMonth setYear).!

calendar
    self changed: #label.
    ^Date calendarForMonth: month year: year!

label
    ^month, ' ', year printString!

month
    ^month!

nextMonth
        "advance to next month"
    | newMonthIndex |
    newMonthIndex := (Date indexOfMonth: month) + 1.
    newMonthIndex > 12
        ifTrue: [ 
            newMonthIndex := 1.
            year := year + 1].
    month := Date nameOfMonth: newMonthIndex.
    self changed: #calendar!

nextYear
        "go back one year"
    year := year + 1.
    self changed: #calendar!

open
    | topPane |
    month := Date today monthName.
    year := Date today year.
    topPane := TopPane new
        label: self label;
        model: self;
        minimumSize: 22@9;       
        yourself.
    topPane addSubpane:
        (TextPane new
            model: self;
            name: #calendar;
            menu: #browseMenu;
            framingBlock: [ :box | box]).    
    topPane dispatcher open scheduleWindow!

priorMonth
        "go back one month"
    | newMonthIndex |
    newMonthIndex := (Date indexOfMonth: month) - 1.
    newMonthIndex < 1 
        ifTrue: [ 
            newMonthIndex := 12.
            year := year - 1].
    month := Date nameOfMonth: newMonthIndex.
    self changed: #calendar!

priorYear
        "go back one year"
    year := year - 1.
    self changed: #calendar!

setMonth 
    | newMonth |
    newMonth := Prompter
        prompt: 'Month?' 
        default: month.  
    newMonth == nil
        ifTrue: [^nil].
    month := Date nameOfMonth: (Date indexOfMonth:
        (Date monthNameFromString: newMonth)). 
    self changed: #calendar!

setYear                                            
    | newYear |
    newYear := Prompter 
        prompt: 'Year?' 
        default: year printString.
    newYear isNil 
        ifTrue: [^nil].
    year := newYear asInteger. 
    self changed: #calendar!

year
    ^year! !
