
Number subclass: #ComplexNumber
  instanceVariableNames: 
    'real imaginary '
  classVariableNames: ''
  poolDictionaries: '' !

! ComplexNumber class methods !

real: realPart imaginary: imaginaryPart
    ^self new real: realPart imaginary: imaginaryPart! !


! ComplexNumber methods !

* aNumber
    | realPart imaginaryPart |
    realPart := ((self real * aNumber real) -
                (self imaginary * aNumber imaginary)).
    imaginaryPart := ((self real * aNumber imaginary) +
                     (self imaginary * aNumber real)).
    imaginaryPart = 0
        ifTrue: [^realPart]
        ifFalse: [^ComplexNumber real: realPart imaginary: imaginaryPart]!

+ aNumber
    |realPart imaginaryPart|
    realPart := ((self real) + (aNumber real)).
    imaginaryPart := ((self imaginary) + (aNumber imaginary)).
    imaginaryPart = 0
        ifTrue: [^realPart]
        ifFalse: [^ComplexNumber real: realPart imaginary: imaginaryPart]!

- aNumber
    |realPart imaginaryPart|
    realPart := ((self real) - (aNumber real)).
    imaginaryPart := ((self imaginary) - (aNumber imaginary)).
    imaginaryPart = 0
        ifTrue: [^realPart]
        ifFalse: [^ComplexNumber real: realPart imaginary: imaginaryPart]!

/ aNumber
    |realPart imaginaryPart|
    realPart := ((self real * aNumber real) +
                (self imaginary * aNumber imaginary)) / (aNumber absSquared).
    imaginaryPart := ((self real * aNumber imaginary) -
                     (self imaginary * aNumber real)) / (aNumber absSquared).
    imaginaryPart = 0
        ifTrue: [^realPart]
        ifFalse: [^ComplexNumber real: realPart imaginary: imaginaryPart]!

< aNumber
    self error: 'Can''t compare complex numbers.'!

<= aNumber
    self error: 'Can''t compare complex numbers.'!

= aNumber
    ^(self real = aNumber real) and: [self imaginary = aNumber imaginary]!

> aNumber
    self error: 'Can''t compare complex numbers.'!

>= aNumber
    self error: 'Can''t compare complex numbers.'!

absSquared
    ^(self real * self real) + (self imaginary * self imaginary)!

asComplex
    ^self!

imaginary
    ^imaginary!

printOn: aStream
    self real = 0 ifFalse: [
        self real printOn:aStream.
        aStream nextPutAll: ' + '].
    self imaginary printOn: aStream.
    aStream nextPutAll: ' i'!

real
    ^real!

real: realPart imaginary: imaginaryPart
    ((realPart class == ComplexNumber) or: [imaginaryPart == ComplexNumber])
        ifTrue: [self error: 'Real numbers must be used.'].
    real := realPart.
    imaginary := imaginaryPart! !



