
Object subclass: #Directory
  instanceVariableNames: 
    'pathName diskette '
  classVariableNames: ''
  poolDictionaries: '' !

! Directory class methods !

create: newPathName
    "Create a DOS directory on disk with
     complete path name newPathName."
    self dosError:
        (Dos asciizPrimitives: 16r3900 with: newPathName asAsciiZ)!

current
    "Answer a Directory representing
     the current DOS directory."
    | aString index |
    aString := String new: 67.
    self dosError:
        (Dos getCurrentDirectory: Disk drive into: aString ).
    index := 3.
    aString := aString asLowerCase.
    [(aString at: index) asciiValue > 0]
        whileTrue: [index := index + 1].
    ^Directory new
        drive: (aString at: 1);
        pathName: (aString copyFrom: 3 to: index - 1)!

remove: aString
        "Remove the DOS directory with
         the path name of aString."
    | anInteger |
    anInteger := Dos
        asciizPrimitives: 16r3A00 with: aString asAsciiZ.
    anInteger = -5
        ifTrue: [self dosError: -19]
        ifFalse: [self dosError: anInteger]!

setTo: aString
        "Make the path name in aString
         the current DOS directory."
    self dosError:
        (Dos asciizPrimitives: 16r3B00 with: aString asAsciiZ)! !


! Directory methods !

= aDirectory
    "Answer true if aDirectory represents the
     same directory as the receiver, else
     answer false."
    (aDirectory isKindOf: Directory)
        ifFalse: [^false].
    ^diskette == aDirectory diskette
        and: [pathName = aDirectory pathName]!

create
    "Create a DOS directory on disk
     for the receiver directory."
    Directory create: (String with: diskette drive),
        ':', pathName! !
