
OldWriteStream subclass: #OldReadWriteStream
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: '' !

! OldReadWriteStream class methods ! !


! OldReadWriteStream methods !

contents
        "Answer the collection over which the receiver is
         streaming."
    ^self copyFrom: 1 to: self readLimit!

next
        "Answer the next object accessible by the receiver
         and advance the stream position.  Report an error
         if the receiver stream is positioned at end."
    | index |
    <primitive: 65>
    self atEnd
        ifTrue: [
            ^self error: 'read beyond end of stream']
        ifFalse: [
            index := self position + 1.
            self position: index.
            ^collection at: index]!

nextPut: anObject
        "Write anObject to the receiver stream.
         Answer anObject."
    readLimit := self position + 1 max: readLimit.
    ^super nextPut: anObject!

nextPutAll: aCollection
        "Write each of the objects in aCollection
         to the receiver stream.  Answer aCollection."
    super nextPutAll: aCollection.
    readLimit < position
        ifTrue: [readLimit := position].
    ^aCollection!

setLimits
        "Private - Initialize the receiver's size and position."
    position := 0.
    readLimit := writeLimit := collection size!

setToEnd
        "Set the position of the receiver stream to
         the end."
    self position: self readLimit!

truncate
        "Set the size of the receiver stream to
         its current position."
    readLimit := position! !
