
Stream subclass: #PositionableStream
  instanceVariableNames: 
    'buffer position limit '
  classVariableNames: ''
  poolDictionaries: 
    'CharacterConstants ' !

! PositionableStream class methods ! !


! PositionableStream methods !

close
    "Provided for compatibility with FileStreams.
     Default is do nothing."!

copyFrom: firstIndex to: lastIndex
    "Answer the subbuffer of the buffer over
     which the receiver is streaming, from firstIndex
     to lastIndex."
    ^buffer copyFrom: firstIndex to: lastIndex.!

countBlanks
        "Skip over blank and tab characters.  Answer the
         number of character positions skipped, counting
         1 for blanks and 4 for tabs."
    | answer char |
    answer := 0.
    [self atEnd]
        whileFalse: [
            char := self next.
            char == $ 
                ifTrue: [answer := answer + 1]
                ifFalse: [
                    char == Tab
                        ifTrue: [answer := answer + 4]
                        ifFalse: [
                            self position: self position - 1.
                            ^answer]]].
    ^answer! !
