
System variableWordSubclass: #Registers
  classVariableNames: 
    'CallUnit '
  poolDictionaries: '' !

! Registers class methods !

callUnit
    ^CallUnit!

initialize
    CallUnit := self new!

new
    ^self new: 5! !


! Registers methods !

al
    ^(self at: 1) bitAnd: 16rFF!

ax
    ^self at: 1!

ax: anInteger
    self at: 1 put: anInteger!

bx
    ^self at: 2!

bx: anInteger
    self at: 2 put: anInteger!

carry
    ^((self at: 5) bitAnd: 1) = 1!

cx
    ^self at: 3!

cx: anInteger
    self at: 3 put: anInteger!

dosCall
    <primitive: 130>!

dosCall: anObject
    "Set DS:DX to the address of anObject which is not a pointer object."
    <primitive: 131>!

dosCall: anObject withDTA: dta
    "Set DS:DX to the address of anObject which is not a pointer object.
     DTA will be reset to the previous position to prevent to be relocated
     by Garbage collector."
    <primitive: 133>!

dosCallATI
    "Allocation table information."
    <primitive: 135>!

dosCallWith: anObject
    "Set DS:SI to the address of anObject which is not a pointer object."
    <primitive: 132>!

dosCallWithDTA: dta
    "DTA will be reset to the previous position to prevent to be relocated
     by Garbage collector."
    <primitive: 134>!

dosRename: oldString to: newString
    <primitive: 136>!

dx
    ^self at: 4!

dx: anInteger
    self at: 4 put: anInteger!

flags
    ^self at: 5!

interrupt: anInteger
    <primitive: 140>! !
