Transcript cr; show: 'Filing in ControlApparatus'!

Object subclass: #ControlApparatus
  instanceVariableNames: 
    'form frame foreColor backColor dependentArray lastChange '
  classVariableNames: ''
  poolDictionaries: '' !

!ControlApparatus class methods ! !


!ControlApparatus methods !

contains: aPoint
        "Answer true if the frame on the
         screen contains aPoint (relative
         to frame). Else answer
         false."
    ^frame containsPoint: aPoint - form offset!

dependentArray
        "Answer the dependentArray."
    ^dependentArray!

dependentArray: anArray
        "Set the dependentArray to anArray."
    dependentArray := anArray!

form: aForm
    frame: aRectangle
        "Initialize form, frame and
         default colors."
    form := aForm.
    frame := aRectangle.
    foreColor := Form black.
    backColor := Form white.
    dependentArray := #()!

frame
        "Answer the framing rectangle of the receiver."
    ^frame!

lastChange
        "Answer the last change."
    ^lastChange!

lastChange: anInteger
        "Set the last change
         to anInteger."
    lastChange := anInteger!

paintLabel: aString
    labelLoc: aPoint
    labelFont: aFont
        "Write the label aString at aPoint
         with aFont."
    | scanner |
    scanner := CharacterScanner new.
    scanner
        initialize: frame
            font: aFont
            dest: form;
        setForeColor: foreColor
            backColor: backColor;
        display: aString
            from: 1
            to: aString size
            at: aPoint - frame origin! !
