Transcript cr; show: 'Filing in ControlPanel'!

Object subclass: #ControlPanel
  instanceVariableNames: 
    'dials '
  classVariableNames: ''
  poolDictionaries: '' !

!ControlPanel class methods ! !


!ControlPanel methods !

changed: aSymbol
        "The dial denoted by aSymbol has been changed,
         notify all dependent dials that have not changed yet."
    | dial |
    dial := dials at: aSymbol.
    dial lastChange = 0
        ifTrue: [
            self perform: aSymbol.
            dial lastChange = 0
                ifTrue: [^self]].
    dial dependentArray do: [:bSymbol |
        (dials at: bSymbol) lastChange = 0
            ifTrue: [self changed: bSymbol]]!

open: aString
        "Open a control panel with the
         label aString."
    | topPane |
    topPane := TopPane new
        label: aString;
        minimumSize: 400 @ (360 * Aspect) truncated;
        menu: #topMenu;
        model: self;
        yourself.
    topPane addSubpane:
        (GraphPane new
            model: self;
            name: #panel:;
            menu: #menu;
            change: #panelChange:;
            framingBlock: [:box| box]).
    topPane dispatcher open scheduleWindow!

panelChange: aPoint
        "Find the apparatus containing aPoint
         and then change its reading to aPoint."
    | dial |
    dials associationsDo: [ :assoc |
        ((dial := assoc value) contains: aPoint)
            ifTrue: [
                dials do: [ :aDial |
                    aDial lastChange: 0].
                dial setToPoint: aPoint.
                dial lastChange = 0 ifFalse: [
                    self changed: assoc key].
                ^self]]! !
