Transcript cr; show: 'Filing in FormEditor'!

ScrollDispatcher subclass: #FormEditor
  instanceVariableNames: 
    'model '
  classVariableNames: ''
  poolDictionaries: 
    'FunctionKeys CharacterConstants ' !

!FormEditor class methods ! !


!FormEditor methods !

mouseScroll
        "Private - Perform mouse scroll."
    | oldLoc |
    oldLoc := Terminal mouseOffset.
    CursorManager hand change.
    pane scrollBarInit.
    [Terminal read == ScrollDownFunction]
        whileFalse: [
            oldLoc := pane scrollHand: oldLoc
                to: Cursor offset].
    CursorManager normal change!

pane: aPane
        "Set the receiver pane to be aPane
         and initialize the receiver."
    super pane: aPane.
    model := aPane model!

processControlKey: aCharacter
        "Private - Process control keys like back-space,
         carriage-return, line-feed, and tab."
    Bs == aCharacter
        ifTrue: [^model backspace].
    (Cr == aCharacter or: [Lf == aCharacter])
        ifTrue: [^model lineFeed].
    super processControlKey: aCharacter!

processFunctionKey: aCharacter
        "Private - Process function keys from the
         keyboard or mouse."
    SetLoc == aCharacter
        ifTrue: [
            Terminal mouseSelectOn
                ifTrue: [^model input: SelectToFunction]].
    ((SelectFunction == aCharacter or: [
    SelectToFunction == aCharacter]) or: [
    aCharacter == EndSelectFunction])
        ifTrue: [^model input: aCharacter].
    super processFunctionKey: aCharacter!

processInputKey: aCharacter
        "An input character has been typed,
         ask the model to process it."
    model inputChar: aCharacter! !
