"This is a file of useful Smalltalk expressions.  To evaluate any
 of these expressions, first select it, then use the pane menu
 function 'do it' or 'show it'."


"To make a new global variable.  This example makes the global
 variable 'Friend'.  Note that global variables are Symbols (that 
 is why the '#' is in front of the name) and they should start
 with a capital letter"

    Smalltalk at: #Friend put: nil.


"To assign a value to a global variable.  In this example we are
 assigning a new instance of the class Example to the global
 variable 'Friend'."

    Friend := Example new.              


"To see the class of a global variable"

    Friend class.


"To see the current value of a global variable"

    Friend.


"To make a FileStream on a file.  In this example we are making
 a FileStream on the file 'sample.sml' in the Disk directory,
 (the directory where the image file is)."

   stream := Disk file: 'sample.sml'.


"To make a Directory.  In this example we are making
 a Directory for the root directory on device A:."
    
    | diskA |
    diskA := Directory new device: $A pathName: '\'.


"To list the contents of the 'read.me' file in the current
 directory (Disk)"

    | readme |
    readme := Disk file: 'read.me'.
    [readme atEnd]
         whileFalse: [Transcript nextPut: readme next].


"To compress the change log file.  Read chapter 8 in the Methods
 Owner's Manual, Maintaining Methods, before evaluating this
 expression"

    Smalltalk compressChanges.


"To compress the source file.  Read chapter 8 in the Methods
 Owner's Manual, Compressing the Source File, before evaluating
 this expression"

    Smalltalk compressSources.


"To clone the Methods environment.  The Cloner classes are not 
 resident in Methods.  The following expression reads and executes 
 a file.  This file installs several classes into Methods and then
 uses them to clone the system.  The cloned system does not contain
 the cloning classes.  Cloning removes all unused Symbols and
 it reassigns all of the object pointers to be in the low end
 of the object pointer space.  It can also be used to build a
 version of the system that has many of the classes removed.
 The expression below assumes that the file 'cloner' is in the 
 Disk directory (the current directory)"

    (Disk file: 'cloner') fileIn.

