Transcript cr; show: 'Filing in Switch'!

ControlApparatus subclass: #Switch
  instanceVariableNames: 
    'areas selection '
  classVariableNames: ''
  poolDictionaries: '' !

!Switch class methods ! !


!Switch methods !

loc: locArray
    size: aPoint
        "Initialize an array of rectangles
         containing switches. Their origins
         are in locArray, extent is aPoint."
    | index |
    selection := 0.
    areas := Array new: locArray size.
    index := 1.
    locArray do: [ :loc |
        areas at: index put: (loc extent: aPoint).
        index := index + 1]!

loc: locArray
    size: aPoint
    label: labelArray
    labelLoc: labLocArray
    font: aFont
        "Initialize an array of rectangles
         containing switches. Their origins
         are in locArray, extent is aPoint.
         Arguments labelArray, labLocArray,
         and aFont allow for printing labels."
    | index |
    self loc: locArray size: aPoint.
    1 to: areas size do: [ :switch |
        self draw: switch].
    1 to: labelArray size do: [ :i |
        self
            paintLabel: (labelArray at: i)
            labelLoc: (labLocArray at: i) + frame origin
            labelFont: aFont].
    self reverse: selection!

selection
        "Answer the current selection
         (switch number selected)."
    ^selection!

selection: anInteger
        "Set selection to anInteger
         (a switch index)."
    self reverse: selection.
    self reverse: anInteger.
    selection := anInteger!

setToPoint: aPoint
        "Set the switch containing aPoint
         to be on."
    | area point |
    point := aPoint - frame origin.
    1 to: areas size do: [ :i |
        area := areas at: i.
        (area containsPoint: point)
            ifTrue: [
                (self switch: i contain: point)
                    ifTrue: [
                        lastChange := 0.
                        i = selection
                            ifFalse: [
                                lastChange := 1.
                                self selection: i].
                        ^selection]]].
    ^nil! !
