
!Time class methods !
mouseClockValue
        "Answer the current second and millisecond
         clock value as milliseconds (used for timing
         mouse events)."
    self currentTimeInto: ValueArray.
    ^(ValueArray at: 3) * 1000 + (ValueArray at: 4)! !  

!ScrollDispatcher methods !
scrollDelay: cursor
        "Private - Perform a delay between each scroll of a
         continuous scroll.  For page scroll, the
         delay time is a constant.  For line scroll,
         it is a function of the distance between the
         cursor and the top-right corner of the
         current pane."
    | delay frame aTime delay2 |
    PageScroll
        ifTrue: [delay := 3]
        ifFalse: [
            frame := pane frame.
            delay := 5
                * (frame corner x - cursor x)
                // frame width].
    [delay > 0]
        whileTrue: [
            delay2 := 1000.
            [delay2 > 0]
                whileTrue: [delay2 := delay2 - 1].
            delay := delay - 1]! !  

!DisplayScreen class methods !
backgroundColor: aForm
        "Repaint the background on the receiver."
    Display
        fill: (0@0 extent: Display extent)
        rule: Form over
        mask: (BackColor := aForm)! !  

!TerminalStream methods !
overClickDelay
        "Private - Answer true when the delay
         time has elapsed, else answer false."
    | aTime | 
    ^(mouseTime := mouseTime + 1) > self delay! !  

!TerminalStream methods !
rightButton: aCharacter
        "Private - Answer SetLoc when the right mouse button
         is pressed without the shift key down,  else
         answer PageUpFunction.  This method changes the state
         to beginMenu and records the time when the right
         button is pressed (for the delay mechanism)."
    state := #beginMenu.
    mouseOffset := Cursor offset.
    mouseTime := 0.
    ^SetLoc! !          

!TerminalStream methods !
delay
        "Private - Answer the milliseconds defining the
         amount of time a mouse button has to stay pressed
         before it can change its function."
    ^350! ! 

!TerminalStream methods !
leftButton: aCharacter
        "Private - Answer SelectFunction when the left mouse
         button is pressed without the shift key down,
         else answer SelectToFunction.  This method changes
         the state to beginSelect and records the time when the
         left button is pressed (for the delay mechanism)."
    state := #beginSelect.
    aCharacter = 16r101 "left button down"
        ifTrue: [
            mouseOffset := Cursor offset.
            mouseTime := 0.
            ^SelectFunction].
    "shift key must be down 16r1101"
    ^SelectToFunction! ! 
